/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * e:/builds/moz2_slave/mozilla-central-win32-xulrunner/build/toolkit/mozapps/extensions/amIWebInstaller.idl
 */

package org.mozilla.interfaces;

/**
 * This interface is used to allow webpages to start installing add-ons.
 */
public interface amIWebInstaller extends nsISupports {

  String AMIWEBINSTALLER_IID =
    "{4fdf4f84-73dc-4857-9bbe-84895e8afd5d}";

  /**
   * Checks if installation is enabled for a webpage.
   *
   * @param  aMimetype
   *         The mimetype for the add-on to be installed
   * @param  referer
   *         The URL of the webpage trying to install an add-on
   * @return true if installation is enabled
   */
  boolean isInstallEnabled(String aMimetype, nsIURI aReferer);

  /**
   * Installs an array of add-ons at the request of a webpage
   *
   * @param  aMimetype
   *         The mimetype for the add-ons
   * @param  aWindow
   *         The window installing the add-ons
   * @param  aReferer
   *         The URI for the webpage installing the add-ons
   * @param  aUris
   *         The URIs of add-ons to be installed
   * @param  aHashes
   *         The hashes for the add-ons to be installed
   * @param  aNames
   *         The names for the add-ons to be installed
   * @param  aIcons
   *         The icons for the add-ons to be installed
   * @param  aCallback
   *         An optional callback to notify about installation success and
   *         failure
   * @param  aInstallCount
   *         An optional argument including the number of add-ons to install
   * @return true if the installation was successfully started
   */
  boolean installAddonsFromWebpage(String aMimetype, nsIDOMWindowInternal aWindow, nsIURI aReferer, String[] aUris, String[] aHashes, String[] aNames, String[] aIcons, amIInstallCallback aCallback, long aInstallCount);

}